// (C) SSoft z-print@bk.ru
//  скрипт для Adobe Acrobat 
//  размещает страницы из файла А5 по 3 на странице А4 на в новый файл, по заданным координатам
//  в Add-on Tools появится скрипт Place 3 pages

//  размеры листа, на который будет собираться макет
const SHEETW = 297
const SHEETH = 210
//  размеры исходной страницы
const SRCPGH = 210
const SRCPGW = 148
//  х-координаты для размещения страниц, первая в паре - левая, вторая - правая
//  меняя правое поле (второе значение), можно подрезать ширину импортируемой страницы
const posX = [[0, SRCPGW], [40, 40 + SRCPGW], [150, 150 + SRCPGW]];

// файл с фоновым изображением, которое будет подкалдываться под странички, чтобы поля не были прозрачными и не игнорировались
// по умолчаниюдолжен лежать в той же папке, что и файл со страничками
const WATERMARKNAME = 'watermark.pdf';

const PGPUT = 3; //  количество страниц для размещения


const cmName = "Place 3 pages";
const cmProc = "place3pages()"
if (app.viewerVersion < 10) {
    app.addMenuItem({ cName: cmName, cUser: cmName, cParent: "Tools", cExec: cmProc, cEnable: "event.rc = (event.target != null);"});
} else {
    app.addToolButton({ cName: cmName, cLabel: cmName, cExec: cmProc, cEnable: "event.rc = (event.target != null);"});   
};    


//  конвертирует из миллиметров в пункты
mm2pt = function (mm) {
    return mm * 2.834;
};

place3pages = app.trustedFunction(function() {
	app.beginPriv();
	outDoc = app.newDoc(mm2pt(SHEETW), mm2pt(SHEETH));
	var aRect = [];
	//  эта часть нужна только при добавлении watermark'ов к страницам
	//  эти строчки просто для унификации
	var srcDoc = this;
	var srcFileName = this.path;
	
	/*  здесь мы добавляем ко всем страницам фон из файла на задний план
	и сохраняем копию исходного файла, чтобы не портить исходник,
	далее будем брать странички из файла с фоном  
	это нужно, чтобы правильно работало выравнивание страницы на листе */
	//  сгенерим имя файла с вотермарками, файл с именем WATERMAKNAME должен лежать в той же папке, 
	//  что и исходный файл

	//  разберем путь к файлу на части
	var wmDocPath = srcFileName.split("/");
	//  заменим имя файла
	wmDocPath[wmDocPath.length - 1] = WATERMARKNAME;
	//  соберем путь обратно
	wmName = wmDocPath.join("/");

	srcDoc.addWatermarkFromFile(wmName, 0, nStart = 0, nEnd = srcDoc.numPages - 1, 
		bOnTop = false, bOnScreen = false, bOnPrint = false, nScale = -1); //  nOpacity = 0 делать watermark прозрачным нет смысла - он игнорируется!
	//  сменим имя у копии
	srcFileName = srcFileName.replace(/\.pdf/i, "_watermarked.pdf");
	//  сохраним копию
	srcDoc.saveAs(srcFileName);
	//  и здесь у нас незаметно сменилось имя рабочего (исходного файла). Внимательно!	


	var t = app.thermometer; // acquire a thermometer object
	//  зададим максимальное значение прогресс-бара
	t.duration = srcDoc.numPages;
	t.begin();
	
	for (var i = 0; (i + PGPUT) <= srcDoc.numPages; i += PGPUT) {
		if (t.cancelled) break;
		t.value = i;
		t.text = "Processing range " + (i + 1) + " - " + (i + PGPUT + 1);
		for (var j = 0; j < PGPUT; j++) {
			// console.println("pg_" + (i + j));
			aRect =  [mm2pt(posX[j][0]), mm2pt(SHEETH), mm2pt(posX[j][1]), mm2pt(0)]; 
			var f = outDoc.addField("pg_" + (i + j), "button", outDoc.numPages - 1, aRect);
			f.buttonImportIcon(srcFileName, i + j);
			f.buttonFitBounds = false;
			f.buttonScaleWhen = scaleWhen.never;
			f.buttonPosition = position.iconOnly;
			f.lineWidth = 0;

			/*  выровняем странички по вреху и левому краю кнопки (в данном случае верху листа)
				у выравниваний есть побочный эффект при пустых полях на исходных страницах
			  	они игнорируются, и в край уходит прям до изображения
			  	выходом может быть добавление watermark'a/фона к страницам оригинального файла
			 	и получение страничек из этой копии.
			 	Пример приведен выше */

			f.buttonAlignY = 100; //  прижмем страничку к верху листа (точне, верхнему краю кнопки)
			f.buttonAlignX = 0;   //  выровняем страничку по левому краю кнопки
			
		};
		outDoc.newPage(outDoc.numPages, mm2pt(SHEETW), mm2pt(SHEETH));
	}
	outDoc.flattenPages();
	outDoc.deletePages(outDoc.numPages - 1);
	t.end();
	app.endPriv();
})
